<?php

// -----------------------------------------------
// exit_local()
// -----------------------------------------------
function exit_local($print_err = 1) {
    drop_temp_table($print_err);
    exit;
}

// -----------------------------------------------
// print_error_local($str)
// -----------------------------------------------
function print_error_local($str){
    global $error;
    
    $error=$str;

    print_template('error');
    print_template('bottom');
    
    exit;
}

// -----------------------------------------------
// get_doc_count()
// -----------------------------------------------
function get_doc_count() {
    global $udm_agent;

    if (Udm_Api_Version() >= 30111) {
	return(Udm_Get_Doc_Count($udm_agent));
    } else {
    	return "Unknown";
    } 
} 


// -----------------------------------------------
// format_lastmod($lastmod)
// -----------------------------------------------
function format_lastmod($lastmod) {
	$temp=$lastmod;
	if (!$temp) $temp = 'undefined';
	elseif (Udm_Api_Version() < 30204) $temp = strftime('%a, %d %b %Y %H:%M:%S %Z',$temp);

	return $temp;
}

// -----------------------------------------------
// format_dp($dp)
// -----------------------------------------------
function format_dp($dp) {
	$result=0;

	while ($dp != '') {		
		if (preg_match('/^([\-\+]?\d+)([sMhdmy]?)/',$dp,$param)) {			
			switch ($param[2]) {
				case 's':  $multiplier=1; break;
                                case 'M':  $multiplier=60; break;
                                case 'h':  $multiplier=3600; break;
                                case 'd':  $multiplier=3600*24; break;
                                case 'm':  $multiplier=3600*24*31; break;
                                case 'y':  $multiplier=3600*24*365; break;
				default: $multiplier=1;
			}

			$result += $param[1]*$multiplier;
                        $dp=preg_replace("/^[\-\+]?\d+$param[2]/",'',$dp);
		} else {
			return 0;
		}
	}

	return $result;
}

// -----------------------------------------------
// format_userdate($date)
// -----------------------------------------------
function format_userdate($date) {
	$result=0;

	if (preg_match('/^(\d+)\/(\d+)\/(\d+)$/',$date,$param)) {
		$day=$param[1];
		$mon=$param[2];
		$year=$param[3];

		$result=mktime(0,0,0,$mon,$day,$year);
	}

	return $result;
}

// -----------------------------------------------
// ParseDocText($text)
// -----------------------------------------------
function ParseDocText($text){
    global $all_words;
    global $hlbeg, $hlend;
       
    $str=$text;

    if (Udm_Api_Version() < 30200) {
    	for ($i=0; $i<count($all_words); $i+=1) {
	    $word=$all_words[$i];
	    $str = preg_replace("/([\s\t\r\n\~\!\@\#\$\%\^\&\*\(\)\-\_\=\+\\\|\{\}\[\]\;\:\'\"\<\>\?\/\,\.]+)($word)/i","\\1$hlbeg\\2$hlend",$str);
	    $str = preg_replace("/^($word)/i","$hlbeg\\1$hlend",$str);
    	}
    } else {
    	$str = str_replace("\2",$hlbeg,$str);
    	$str = str_replace("\3",$hlend,$str);
	while (substr_count($str,$hlbeg) > substr_count($str,$hlend)) {
	    $str.=$hlend;
	}
    }

    return $str;
}

// -------------------------------------
// ParseQString
// -------------------------------------
function ParseQString() {
    global $QUERY_STRING;
    global $ul, $ul_arr;
    global $tag, $tag_arr;
    global $cat, $cat_arr;
    global $lang, $lang_arr;
    global $type, $type_arr;
	
    $pairs = explode("&", $QUERY_STRING);
    $ul_arr = array();
    $tag_arr = array();
    $cat_arr = array();
    $lang_arr = array();
    $type_arr = array();
	
    for($i=0; $i<count($pairs); $i+=1) {
	$pairs[$i]=str_replace('+',' ',$pairs[$i]);
	list($name, $value) = explode("=",$pairs[$i]);
	if ($name=='ul') {
	    $ul_arr[]=urldecode($value);
	    if (!count($ul_arr)) $ul=urldecode($value);
	} elseif ($name=='tag') {
	    $tag_arr[]=urldecode($value);
	    if (!count($tag_arr)) $tag=urldecode($value);
	} elseif ($name=='cat') {
	    $cat_arr[]=urldecode($value);
	    if (!count($cat_arr)) $cat=urldecode($value);
	} elseif ($name=='lang') {
	    $lang_arr[]=urldecode($value);
	    if (!count($lang_arr)) $lang=urldecode($value);
	} elseif ($name=='type') {
	    $type_arr[]=urldecode($value);
	    if (!count($type_arr)) $type=urldecode($value);
	} else continue;
    }
}

?>
